"use strict";
exports.id = 7487;
exports.ids = [7487];
exports.modules = {

/***/ 7487:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const mysql = __webpack_require__(2261);
const grabDbSSL = __webpack_require__(4824);
let NO_DB = mysql({
    config: {
        host: process.env.DSQL_DB_HOST,
        user: process.env.DSQL_DB_USERNAME,
        password: process.env.DSQL_DB_PASSWORD,
        charset: "utf8mb4",
        ssl: grabDbSSL()
    }
});
/**
 * DSQL user read-only DB handler
 * @param {object} params
 * @param {string} params.paradigm
 * @param {string} params.database
 * @param {string} params.queryString
 * @param {string[]} [params.queryValues]
 */ // @ts-ignore
function NO_DB_HANDLER(...args) {
    try {
        return new Promise((resolve, reject)=>{
            NO_DB.query(...args).then((results)=>{
                NO_DB.end();
                resolve(JSON.parse(JSON.stringify(results)));
            }).catch((err)=>{
                NO_DB.end();
                resolve({
                    error: err.message,
                    sql: err.sql
                });
            });
        });
    } catch (/** @type {any} */ error) {
        return {
            success: false,
            error: error.message
        };
    }
}
module.exports = NO_DB_HANDLER;


/***/ })

};
;