"use strict";
(() => {
var exports = {};
exports.id = 1600;
exports.ids = [1600];
exports.modules = {

/***/ 3785:
/***/ ((module) => {

module.exports = require("generate-password");

/***/ }),

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 6109:
/***/ ((module) => {

module.exports = require("sanitize-html");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5241:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(7547);
/* harmony import */ var _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5338);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);
const { execSync  } = __webpack_require__(2081);
const generator = __webpack_require__(3785);




/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ /** @type {import("@/package-shared/types").AddApiKeyRequestBody} */ const reqBody = req.body;
    const { api_key_name , api_key_slug , api_key_scope , target_database , target_table ,  } = reqBody;
    /**
     * Input Validation
     *
     * @description Input Validation
     */ if (!api_key_name?.match(/./) || !api_key_slug?.match(/./) || !api_key_scope?.match(/./)) {
        return res.json({
            success: false,
            msg: "Wrong Input"
        });
    }
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        const allowedKeysPath = process.env.DSQL_API_KEYS_PATH;
        if (!allowedKeysPath) throw new Error("process.env.DSQL_API_KEYS_PATH variable not found");
        if (!fs.existsSync(allowedKeysPath)) {
            fs.mkdirSync(allowedKeysPath, {
                recursive: true
            });
        }
        let sign = generator.generate({
            length: 24,
            numbers: true,
            uppercase: true,
            lowercase: true,
            symbols: "-"
        }) + "-" + Date.now();
        /** @type {import("@/package-shared/types").ApiKeyObject} */ let payload = {
            user_id: user.id,
            date_code: Date.now(),
            sign,
            target_database,
            target_table
        };
        if (api_key_scope == "fullAccess") {
            const extraPayload = {
                full_access: true
            };
            payload = {
                ...payload,
                ...extraPayload
            };
        }
        const apiKey = _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_0___default()(JSON.stringify(payload));
        if (!apiKey) return res.json({
            success: false,
            msg: "Couldn't encrypt API key"
        });
        const encryptedApiKey = _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_0___default()(apiKey);
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ /** @type {any} */ let dbEntryObject = {
            dbFullName: "datasquirel",
            tableName: "api_keys",
            data: {
                user_id: user.id,
                name: api_key_name,
                slug: api_key_slug,
                key: encryptedApiKey,
                scope: api_key_scope
            }
        };
        if (sign) dbEntryObject.data.csrf = sign;
        let newApiKey = await _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_3___default()(dbEntryObject);
        if (!newApiKey.insertId) {
            throw new Error("Api Key Couldn't be added");
        }
        fs.writeFileSync(`${allowedKeysPath}/${sign}`, JSON.stringify(payload), "utf-8");
        res.json({
            success: true
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/addApiKey/catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Database Files could not be written!"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,7547,5886,5338], () => (__webpack_exec__(5241)));
module.exports = __webpack_exports__;

})();