"use strict";
(() => {
var exports = {};
exports.id = 8325;
exports.ids = [8325];
exports.modules = {

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 6109:
/***/ ((module) => {

module.exports = require("sanitize-html");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 2771:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(766);
/* harmony import */ var _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5338);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_utils_backend_global_db_DSQL_USER_DB_HANDLER__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(3403);
/* harmony import */ var _package_shared_utils_backend_global_db_DSQL_USER_DB_HANDLER__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DSQL_USER_DB_HANDLER__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check




/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const checkUserRights = __webpack_require__(8999);
const grabDelegatedUserFromCookie = __webpack_require__(1352);
const serverError = __webpack_require__(2163);
const userAuth = __webpack_require__(6825);
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * @typedef {object} AddTableEntryRequestBody
 * @property {string} tableName
 * @property {any} payload
 * @property {import("@/package-shared/types").DSQL_TableSchemaType} tableSchema
 * @property {string} dbSlug
 * @property {number} dbId
 * @property {boolean} delegated
 */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await userAuth(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "User Auth Failed"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ /** @type {AddTableEntryRequestBody} */ const sanitizedReqBody = req.body;
    const { tableName , payload , tableSchema , dbSlug , dbId , delegated  } = sanitizedReqBody;
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /**
         * Check if user has rights to this table
         *
         * @description Check if user has rights to this table
         */ const delegatedUser = await grabDelegatedUserFromCookie({
            databaseSlug: dbSlug,
            request: req,
            user: user,
            query: req.query
        });
        const checkUserRightsBoolean = await checkUserRights({
            user: user,
            confirmedDelegetedUser: delegatedUser,
            database: dbSlug,
            table: tableName,
            dbId: dbId,
            priviledgeRegex: /Update Entries/i
        });
        if (!checkUserRightsBoolean) {
            return res.json({
                success: false,
                msg: "Unauthorized"
            });
        }
        const dbFullName = delegatedUser?.rootUserId ? `datasquirel_user_${delegatedUser.rootUserId}_${dbSlug}` : `datasquirel_user_${user.id}_${dbSlug}`;
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ const newTableEntry = await _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1___default()({
            dbContext: "Dsql User",
            paradigm: "Full Access",
            dbFullName: dbFullName,
            tableName: tableName,
            data: payload,
            tableSchema: tableSchema
        });
        if (!newTableEntry.insertId) {
            console.log("Table Insertion Failed =>", newTableEntry);
            throw new Error("Table Insertion Failed");
        }
        const handleOrder = await _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0___default()({
            dbName: dbFullName,
            entryId: newTableEntry.insertId,
            entryOrder: payload.order,
            tableName: tableName,
            tableSchema: tableSchema
        });
        ////////////////////////////////////////
        res.json({
            success: true
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        serverError({
            component: "/api/addTableEntry/catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Database Files could not be written!",
            err: error.message
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,7547,5886,5338,1352,8999,766], () => (__webpack_exec__(2771)));
module.exports = __webpack_exports__;

})();