"use strict";
(() => {
var exports = {};
exports.id = 2383;
exports.ids = [2383];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 2037:
/***/ ((module) => {

module.exports = require("os");

/***/ }),

/***/ 5509:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(4432);
/* harmony import */ var _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1__);
// @ts-check
const fs = __webpack_require__(7147);
const os = __webpack_require__(2037);
const { execSync , spawnSync  } = __webpack_require__(2081);


/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        success: false,
        msg: "Wrong Method"
    });
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ const user = await _functions_backend_suAdminUserAuth__WEBPACK_IMPORTED_MODULE_1___default()(req);
    if (!user?.logged_in_status) {
        return res.json({
            success: false,
            log: "Unauthorized"
        });
    }
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    try {
        /**
         * Validate Form
         *
         * @description Check if request body is valid
         */ const dsqlUser = req.body.user;
        const dsqlUserId = dsqlUser.id.toString().replace(/[^0-9]/g, "").replace(/\//g, "");
        const backupFolder = `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${dsqlUserId}/backups`;
        if (!fs.existsSync(backupFolder)) {
            fs.mkdirSync(backupFolder);
        }
        const newBackupFolderName = Date.now().toString();
        fs.mkdirSync(`${backupFolder}/${newBackupFolderName}`);
        ////////////////////////////////////////////////
        ////////////////////////////////////////////////
        ////////////////////////////////////////////////
        const userDatabases = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SHOW databases LIKE ?`, [
            `datasquirel_user_${dsqlUserId}_%`, 
        ]);
        for(let i = 0; i < userDatabases.length; i++){
            const dbObject = userDatabases[i];
            const dbName = Object.values(dbObject)[0].replace(/[^a-z0-9\_]/g, "");
            ////////////////////////////////////////////////
            const mysqlDumpPath = os.platform().match(/win/i) ? "'" + "C:\\Program Files\\MySQL\\MySQL Server 8.0\\bin\\mysqldump.exe" + "'" : "mysqldump";
            /** @type {import("child_process").SpawnSyncOptions} */ let execSyncOptions = {
                cwd: process.cwd()
            };
            const filePath = `${backupFolder}/${newBackupFolderName}/${dbName}.sql`;
            if (os.platform().match(/win/i)) execSyncOptions.shell = "bash.exe";
            const exe = `${mysqlDumpPath} -u ${process.env.DSQL_DB_USERNAME} -h ${process.env.DSQL_DB_HOST} -p${process.env.DSQL_DB_PASSWORD} ${dbName} > ${filePath}`;
            console.log(`addUserBackup.js exe => ${exe}`);
            const dumpDb = spawnSync(mysqlDumpPath, [
                "-u",
                process.env.DSQL_DB_USERNAME,
                "-h",
                process.env.DSQL_DB_HOST,
                `-p${process.env.DSQL_DB_PASSWORD}`,
                dbName,
                ">",
                filePath, 
            ], execSyncOptions);
        // const dumpDb = execSync(mysqlDumpPath, [], execSyncOptions);
        ////////////////////////////////////////////////
        }
        ////////////////////////////////////////////////
        fs.copyFileSync(`${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${dsqlUserId}/main.json`, `${backupFolder}/${newBackupFolderName}/main.json`);
        ////////////////////////////////////////////////
        ////////////////////////////////////////////////
        ////////////////////////////////////////////////
        res.json({
            success: true
        });
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    ////////////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        console.log(error.message);
        res.json({
            success: false
        });
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,4432], () => (__webpack_exec__(5509)));
module.exports = __webpack_exports__;

})();