"use strict";
(() => {
var exports = {};
exports.id = 8607;
exports.ids = [8607];
exports.modules = {

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 8026:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1017);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);




/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const sanitizedReqBody = req.body;
    /** @type {{ url:string, key: string, database: import("@/package-shared/types").DSQL_MYSQL_user_databases_Type, dbSchema: import("@/package-shared/types").DSQL_DatabaseSchemaType, type: "pull" | "push" }} */ const { url , key , database , dbSchema , type  } = sanitizedReqBody;
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /**
         * User auth
         *
         * @description Authenticate user
         */ const authorization = key;
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_1___default()({
            key: key,
            database: database?.db_slug
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        const userJSON = _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2___default()(authorization);
        const remoteUser = userJSON ? JSON.parse(userJSON) : null;
        const { user_id , full_access , csrf  } = remoteUser;
        if (!full_access || !csrf) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        const userSchemaPath = path__WEBPACK_IMPORTED_MODULE_3___default().resolve(String(process.env.DSQL_USER_DB_SCHEMA_PATH), `user-${user_id}`, "main.json");
        if (!fs.existsSync(userSchemaPath)) throw new Error("User Shcema data file doesn't exist!");
        const dbSchema1 = JSON.parse(fs.readFileSync(userSchemaPath, "utf-8"));
        res.json({
            success: true,
            payload: dbSchema1
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        console.log("Connect Verification Error, =>", error.message);
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_0___default()({
            component: "/api/connect/main-catch-error",
            message: error.message
        });
        res.json({
            success: false,
            msg: "Connect Verification Operation Failed!"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2163,1007], () => (__webpack_exec__(8026)));
module.exports = __webpack_exports__;

})();