(() => {
var exports = {};
exports.id = 9569;
exports.ids = [9569];
exports.modules = {

/***/ 6109:
/***/ ((module) => {

"use strict";
module.exports = require("sanitize-html");

/***/ }),

/***/ 2261:
/***/ ((module) => {

"use strict";
module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

"use strict";
module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

"use strict";
module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

"use strict";
module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

"use strict";
module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

"use strict";
module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

"use strict";
module.exports = require("path");

/***/ }),

/***/ 7310:
/***/ ((module) => {

"use strict";
module.exports = require("url");

/***/ }),

/***/ 3837:
/***/ ((module) => {

"use strict";
module.exports = require("util");

/***/ }),

/***/ 8518:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var __webpack_unused_export__;
// @ts-check
const { execSync  } = __webpack_require__(2081);
const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);
// const serverError = require("./serverError");
/**
 * @async
 * @param {object} params
 * @param {number | string} params.userId
 * @param {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} params.dbSchema
 * @param {string} [params.targetDb] - Eg `datasquirel_user_7_db_name`
 * @returns {string}
 */ const dbSchemaExec = ({ userId , dbSchema , targetDb  })=>{
    const userSchemaPath = path.resolve(String(process.env.DSQL_USER_DB_SCHEMA_PATH), `user-${userId}`, "main.json");
    fs.writeFileSync(userSchemaPath, JSON.stringify(dbSchema), "utf-8");
    const targetPath = path.join(process.cwd(), "shell");
    const dbShellUpdate = execSync(`node createDbFromSchema.js --user ${userId}${targetDb ? " --database " + targetDb : ""}`, {
        cwd: targetPath
    });
    return `User ${userId} Db Schema Updated => ${dbShellUpdate.toString("utf-8")}`;
};
/**
 * @async
 * @param {object} params
 * @param {number | string} params.userId
 * @param {import("@/package-shared/types").DSQL_DatabaseSchemaType} params.dbSchema - New Db Schema for `targetDbFullName` variable
 * @param {import("@/package-shared/types").DSQL_MYSQL_user_databases_Type} params.database - Db entry
 * @returns {string}
 */ const dbSchemaExecDbUpdate = ({ userId , dbSchema , database  })=>{
    const userSchemaPath = path.resolve(String(process.env.DSQL_USER_DB_SCHEMA_PATH), `user-${userId}`, "main.json");
    /** @type {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} */ let userDbSchema = JSON.parse(fs.readFileSync(userSchemaPath, "utf-8"));
    const targetDbIndex = userDbSchema.findIndex((db)=>db.dbFullName == database.db_full_name);
    if (targetDbIndex < 0) {
        throw new Error("Target Database not found in user schema data");
    }
    const targetDb = {
        ...userDbSchema[targetDbIndex]
    };
    userDbSchema[targetDbIndex] = dbSchema;
    userDbSchema[targetDbIndex].dbName = targetDb.dbName;
    userDbSchema[targetDbIndex].dbFullName = targetDb.dbFullName;
    userDbSchema[targetDbIndex].dbSlug = targetDb.dbSlug;
    userDbSchema[targetDbIndex].dbImage = targetDb.dbImage;
    return dbSchemaExec({
        dbSchema: userDbSchema,
        userId,
        targetDb: database.db_full_name
    });
};
__webpack_unused_export__ = dbSchemaExec;
exports.H = dbSchemaExecDbUpdate;


/***/ }),

/***/ 2917:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_dbSchemaExec__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(8518);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5886);
/* harmony import */ var _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);
const utils = __webpack_require__(3837);
const { URL  } = __webpack_require__(7310);




/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ const sanitizedReqBody = req.body;
    /** @type {import("@/package-shared/types").DbConnectType} */ const { url , key , database , dbSchema , type , remoteDbs , targetDb  } = sanitizedReqBody;
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        if (!targetDb?.tables) throw new Error("No Target Database");
        /**
         * User auth
         *
         * @description Authenticate user
         */ const updateDb = await _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_3___default()({
            tableName: "user_databases",
            // /** @type {DSQL_MYSQL_user_databases_Type} */
            data: {
                remote_connected: 1,
                remote_connection_host: url,
                remote_connection_key: key,
                remote_connection_type: type,
                remote_db_full_name: targetDb.dbFullName
            },
            identifierColumnName: "db_full_name",
            identifierValue: database.db_full_name
        });
        const update = (0,_functions_backend_dbSchemaExec__WEBPACK_IMPORTED_MODULE_0__/* .dbSchemaExecDbUpdate */ .H)({
            dbSchema: targetDb,
            database: database,
            userId: user.id
        });
        res.json({
            success: true
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        console.log("Connect Handshake Error, =>", error.message);
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/connect/verify/main-catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Operation Failed!"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,7547,5886], () => (__webpack_exec__(2917)));
module.exports = __webpack_exports__;

})();