"use strict";
(() => {
var exports = {};
exports.id = 820;
exports.ids = [820];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 2562:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1017);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);




/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ const sanitizedReqBody = req.body;
    const { folder  } = sanitizedReqBody;
    try {
        /**
         * ### Clean Target Folder
         * @param {object} params
         * @param {string} params.path
         */ async function cleanFolder({ path  }) {
            try {
                const folderFiles = fs.readdirSync(path);
                for(let i = 0; i < folderFiles.length; i++){
                    const fileName = folderFiles[i];
                    if (!fileName.match(/\..{3,4}$/)) {
                        await cleanFolder({
                            path: path + fileName + "/"
                        });
                        continue;
                    }
                    const targetFolder = path.replace(/.*user-images\/user-\d+\/|.*jsonData\/dbSchemas\/users\/user-\d+\/media\//, "").replace(/\/+$/, "");
                    const targetMediaInDb = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SELECT * FROM user_media WHERE folder=? && media_url LIKE '%${fileName}'`, [
                        targetFolder
                    ]);
                    if (targetMediaInDb && targetMediaInDb[0]) {
                        await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`DELETE FROM user_media WHERE id = ?`, [
                            targetMediaInDb[0].id
                        ]);
                    }
                    try {
                        fs.unlinkSync(path + fileName);
                    } catch (error1) {
                        try {
                            fs.rmdirSync(path + fileName);
                        } catch (error) {}
                    }
                }
                fs.rmdirSync(path);
            } catch (/** @type {any} */ error2) {
                console.log("File cleaning error =>", error2.message);
            }
        }
        const STATIC_ROOT = process.env.DSQL_STATIC_SERVER_DIR;
        if (!STATIC_ROOT) {
            console.log("Static File ENV not Found!");
            throw new Error("No Static Path!");
        }
        const folderPath = path__WEBPACK_IMPORTED_MODULE_3___default().join(STATIC_ROOT, `images/user-images/user-${user.id}/`);
        const privateFolderPath = `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${user.id}/media/`;
        const fullFolderPath = folderPath + (folder ? folder.replace(/\.| /g, "") + "/" : "");
        const fullPrivateFolderPath = privateFolderPath + (folder ? folder.replace(/\.| /g, "") + "/" : "");
        await cleanFolder({
            path: fullFolderPath
        });
        await cleanFolder({
            path: fullPrivateFolderPath
        });
        /**
         * Send Response
         *
         * @description Send a boolean response
         */ res.json({
            success: true
        });
    } catch (/** @type {any} */ error) {
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/deleteMediaFolder/main-catch-error",
            message: error.message,
            user: user
        });
        /**
         * Send Error Response
         *
         * @description Send a boolean response
         */ res.json({
            success: false
        });
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825], () => (__webpack_exec__(2562)));
module.exports = __webpack_exports__;

})();