"use strict";
(() => {
var exports = {};
exports.id = 8362;
exports.ids = [8362];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 1118:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1311);
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_0__);
// @ts-check

/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const checkUserRights = __webpack_require__(8999);
const grabDelegatedUserFromCookie = __webpack_require__(1352);
const serverError = __webpack_require__(2163);
const userAuth = __webpack_require__(6825);
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * @typedef {object} FetchEntriesBasicBody
 * @property {string} tableName
 * @property {string} dbSlug
 * @property {number} dbId
 * @property {boolean} [isTitle]
 * @property {boolean} [isSlug]
 * @property {boolean} [isFullName]
 * @property {string} [defaultField]
 */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await userAuth(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "User Auth Failed"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ /** @type {FetchEntriesBasicBody} */ const { tableName , dbSlug , dbId , isTitle , isSlug , isFullName , defaultField ,  } = req.body;
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /**
         * Check if user has rights to this table
         *
         * @description Check if user has rights to this table
         */ const delegatedUser = await grabDelegatedUserFromCookie({
            databaseSlug: dbSlug,
            request: req,
            user: user,
            query: req.query
        });
        const checkUserRightsBoolean = await checkUserRights({
            user: user,
            confirmedDelegetedUser: delegatedUser,
            database: dbSlug,
            table: tableName,
            dbId: dbId,
            priviledgeRegex: /Update Entries/i
        });
        if (!checkUserRightsBoolean) {
            return res.json({
                success: false,
                msg: "Unauthorized"
            });
        }
        const dbFullName = delegatedUser?.rootUserId ? `datasquirel_user_${delegatedUser.rootUserId}_${dbSlug}` : `datasquirel_user_${user.id}_${dbSlug}`;
        const queryString = `SELECT id${isTitle ? ",title" : isSlug ? ",slug" : isFullName ? ",CONCAT(first_name, ' ', last_name) AS full_name" : defaultField ? "," + defaultField : ""} FROM ${tableName}`;
        const entries = await _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_0___default()({
            database: dbFullName,
            queryString: queryString
        });
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ ////////////////////////////////////////
        res.json({
            success: true,
            entries
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        serverError({
            component: "/api/addTableEntry/catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Database Files could not be written!",
            err: error.message
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,8326,1311,1352,8999], () => (__webpack_exec__(1118)));
module.exports = __webpack_exports__;

})();