"use strict";
(() => {
var exports = {};
exports.id = 1146;
exports.ids = [1146];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 5989:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(7547);
/* harmony import */ var _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ 



/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_3___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ // const { rootUserId, priviledges, database } = req.body;
    const rootUserId = req.body.rootUserId;
    const priviledges = req.body.priviledges;
    const database = req.body.database;
    /**
     * Input Validation
     *
     * @description Input Validation
     */ try {
        const foundUserUser = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SELECT * FROM user_users WHERE user_id=? AND invited_user_id=? AND MATCH(database_access) AGAINST(?)`, [
            rootUserId,
            user.id,
            database
        ]);
        if (!foundUserUser || !foundUserUser[0]) throw new Error(`user with id ${user.id} has no access to ${database} database belonging to user ${rootUserId}`);
        const foundUserTables = (await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SELECT * FROM delegated_user_tables WHERE root_user_id=? AND delegated_user_id=? AND \`database\`=?`, [
            rootUserId,
            user.id,
            database
        ])).map((/** @type {any} */ tableObject)=>{
            return tableObject.table;
        });
        const rootUserinfo = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SELECT * FROM users WHERE id=?`, [
            rootUserId
        ]);
        const payload = {
            rootUserId: rootUserId,
            rootUserName: `${rootUserinfo[0].first_name} ${rootUserinfo[0].last_name}`,
            rootUserEmail: rootUserinfo[0].email,
            rootUserImage: rootUserinfo[0].image_thumbnail,
            delegatedUserId: user.id,
            databaseFullName: `datasquirel_user_${rootUserId}_${database}`,
            databaseSlug: database,
            allowedTables: foundUserTables,
            priviledges: priviledges,
            dateCreated: Date.now()
        };
        const encryptedPayload = _package_shared_functions_backend_encrypt__WEBPACK_IMPORTED_MODULE_1___default()(JSON.stringify(payload));
        const dbFullName = `${process.env.DSQL_USER_DB_PREFIX}${payload.rootUserId}_${database}`;
        const tokenName = `${process.env.DSQL_USER_DELEGATED_DB_COOKIE_PREFIX}${dbFullName}`;
        res.setHeader("Set-Cookie", [
            `${tokenName}=${encryptedPayload};path=/`, 
        ]);
        res.json({
            success: true,
            msg: "Processed Successfully"
        });
    ////////////////////////////////////////
    ////////////////////////////////////////
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        console.log("ERROR:", error.message);
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default()({
            component: "/api/getDelegatedDatabaseToken/main-catch-error",
            message: error.message,
            user: user
        });
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,7547], () => (__webpack_exec__(5989)));
module.exports = __webpack_exports__;

})();