"use strict";
(() => {
var exports = {};
exports.id = 3419;
exports.ids = [3419];
exports.modules = {

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 6109:
/***/ ((module) => {

module.exports = require("sanitize-html");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 7441:
/***/ ((module) => {

module.exports = require("sharp");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 2518:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "config": () => (/* binding */ config),
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1017);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5338);
/* harmony import */ var _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6147);
/* harmony import */ var _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _functions_backend_fsWriteImageToDiskFromBase64__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(5910);
/* harmony import */ var _functions_backend_fsWriteImageToDiskFromBase64__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_fsWriteImageToDiskFromBase64__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_6___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_6__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);







/** ****************************************************************************** */ const config = {
    api: {
        bodyParser: {
            sizeLimit: "50mb"
        }
    }
};
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** @type {import("next").NextApiHandler} */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ let results;
    try {
        const authorization = req.headers.authorization;
        if (!authorization) throw new Error("No Authorization Found!");
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_6___default()({
            key: authorization
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        const { user_id , full_access  } = apiCred;
        if (!full_access) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        /**
         * User auth
         *
         * @description Authenticate user
         */ let { imageData , imageName , mimeType , thumbnailSize , folder , isPrivate ,  } = req.body;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        const STATIC_ROOT = process.env.DSQL_STATIC_SERVER_DIR;
        if (!STATIC_ROOT) {
            console.log("Static File ENV not Found!");
            throw new Error("No Static Path!");
        }
        if (folder) {
            const folderPath = path__WEBPACK_IMPORTED_MODULE_0___default().join(STATIC_ROOT, `images/user-images/user-${user_id}/${folder}`);
            const folderExists = fs.existsSync(folderPath);
            if (!folderExists) {
                fs.mkdirSync(folderPath, {
                    recursive: true
                });
            }
        }
        /**
         * Input Validation
         *
         * @description Input Validation
         */ const imageType = (()=>{
            if (mimeType?.match(/jpeg/i)) return "jpeg";
            if (mimeType?.match(/png/i)) return "png";
            if (mimeType?.match(/webp/i)) return "webp";
            if (mimeType?.match(/svg/i)) return "svg";
            return "jpg";
        })();
        const writeImage = await _functions_backend_fsWriteImageToDiskFromBase64__WEBPACK_IMPORTED_MODULE_4___default()({
            imageName: imageName,
            imageSourceBase64: imageData,
            user: {
                id: user_id
            },
            mimeType: imageType,
            thumbnailSize: thumbnailSize,
            folder,
            isPrivate
        });
        if (!writeImage) throw new Error("Write Image Failed in add-media API route");
        const { urlPath , urlThumbnailPath  } = writeImage;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        const removeDuplicateMedia = await _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_2___default()({
            dbFullName: "datasquirel",
            tableName: "user_media",
            identifierColumnName: "media_url",
            identifierValue: urlPath
        });
        let newMediaEntry = await _package_shared_functions_backend_db_addDbEntry__WEBPACK_IMPORTED_MODULE_1___default()({
            dbFullName: "datasquirel",
            tableName: "user_media",
            data: {
                user_id: user_id,
                media_name: imageName,
                media_url: urlPath,
                media_thumbnail_url: urlThumbnailPath,
                folder: folder ? folder : ""
            }
        });
        ////////////////////////////////////////
        res.json({
            success: true,
            payload: {
                urlPath,
                urlThumbnailPath
            }
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_5___default()({
            component: "/api/query/add-image/main-catch-error",
            message: error.message,
            user: {}
        });
        res.json({
            success: false,
            msg: "Add Image Error!",
            error: error.message
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,3017,3403,7547,5886,5338,1007,6147,6715,5910], () => (__webpack_exec__(2518)));
module.exports = __webpack_exports__;

})();