"use strict";
(() => {
var exports = {};
exports.id = 1620;
exports.ids = [1620];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 2201:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "config": () => (/* binding */ config),
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(6147);
/* harmony import */ var _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);





/** ****************************************************************************** */ const config = {
    api: {
        bodyParser: {
            sizeLimit: "50mb"
        }
    }
};
/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** @type {import("next").NextApiHandler} */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ let results;
    try {
        const authorization = req.headers.authorization;
        if (!authorization) {
            return res.json({
                success: false,
                msg: "Unauthorized"
            });
        }
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4___default()({
            key: authorization
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        const { user_id , full_access  } = apiCred;
        if (!full_access) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        /**
         * User auth
         *
         * @description Authenticate user
         */ let { url  } = req.body;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        const existingMedia = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_0___default()(`SELECT * FROM user_media WHERE media_url = ?`, [
            url
        ]);
        if (!existingMedia?.length) {
            return res.json({
                success: false,
                msg: "Media not found!"
            });
        }
        const { id , folder , media_url , media_thumbnail_url , media_type  } = existingMedia[0];
        const STATIC_ROOT = process.env.DSQL_STATIC_SERVER_DIR;
        if (!STATIC_ROOT) {
            console.log("Static File ENV not Found!");
            throw new Error("No Static Path!");
        }
        /**
         *
         * @param {string | null | undefined} path
         * @returns {string}
         */ const formPath = (path)=>{
            if (!path) return "";
            if (path?.match(/\.\./)) return "";
            if (path?.match(/^\@/)) {
                return path.replace(/@\/media\//, `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${user_id}/media/`);
            }
            return path.replace(process.env.DSQL_STATIC_HOST || "", STATIC_ROOT);
        };
        const deletePath = formPath(media_url);
        const deleteThumbnailPath = formPath(media_thumbnail_url);
        if (!deletePath?.match(/./)) {
            return res.json({
                success: false,
                msg: "Invalid path!"
            });
        }
        try {
            fs.unlinkSync(deletePath);
            fs.unlinkSync(deleteThumbnailPath);
            ////////////////////////////////////////
            ////////////////////////////////////////
            ////////////////////////////////////////
            const removeDuplicateMedia = await _package_shared_functions_backend_db_deleteDbEntry__WEBPACK_IMPORTED_MODULE_1___default()({
                dbFullName: "datasquirel",
                tableName: "user_media",
                identifierColumnName: "id",
                identifierValue: id
            });
            ////////////////////////////////////////
            res.json({
                success: true,
                payload: {
                    url
                }
            });
        } catch (/** @type {any} */ error) {
            console.log("File delete error:", error.message);
            ////////////////////////////////////////
            res.json({
                success: false,
                payload: {
                    url
                },
                error: error.message
            });
        }
    ////////////////////////////////////////
    } catch (/** @type {any} */ error1) {
        ////////////////////////////////////////
        console.log("File write error:", error1);
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3___default()({
            component: "/api/query/delete-file/main-catch-error",
            message: error1.message
        });
        res.json({
            success: false,
            msg: "Delete File Error!",
            error: error1.message
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,3403,1007,6147], () => (__webpack_exec__(2201)));
module.exports = __webpack_exports__;

})();