"use strict";
(() => {
var exports = {};
exports.id = 8691;
exports.ids = [8691];
exports.modules = {

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 1640:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_2__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);



/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** @type {import("next").NextApiHandler} */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "GET") return res.json({
        msg: "Failed!"
    });
    console.log("Getting DB schema");
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ let results;
    try {
        /** @type {import("@/package-shared/types").GetSchemaRequestQuery} */ // @ts-ignore
        const reqQuery = req.query;
        let { database , table , field  } = reqQuery;
        const authorization = req.headers.authorization;
        if (!authorization) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_2___default()({
            key: authorization,
            database: database,
            table: table
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        const { user_id , full_access  } = apiCred;
        if (!full_access) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ try {
            const dbFullName = database && typeof database == "string" ? `datasquirel_user_${user_id}_${database?.toLowerCase().replace(/[^a-z0-9\_]/g, "")}` : null;
            /** @type {string} */ const dbSchemaPath = path.join(String(process.env.DSQL_USER_DB_SCHEMA_PATH), `user-${user_id.toString().replace(/\//g, "")}`, "main.json");
            /** @type {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} */ const dbSchema = JSON.parse(fs.readFileSync(dbSchemaPath, "utf8"));
            const targetDbSchema = dbFullName ? dbSchema.find((db)=>db.dbFullName == dbFullName) : null;
            if (table && database && targetDbSchema?.tables?.[0]) {
                const targetTable = targetDbSchema.tables.find((tbl)=>tbl.tableName == table);
                if (field && targetTable?.fields?.[0]) {
                    const targetField = targetTable.fields.find((fld)=>fld.fieldName === field);
                    return res.json({
                        success: Boolean(targetField),
                        payload: targetField
                    });
                } else if (field && !targetTable?.fields?.[0]) {
                    throw new Error("Target Table Not Found!");
                }
                return res.json({
                    success: Boolean(targetTable),
                    payload: targetTable
                });
            } else if (table && !targetDbSchema?.tables?.[0]) {
                throw new Error("Target Database Not Found!");
            }
            if (database) {
                res.json({
                    success: Boolean(targetDbSchema),
                    payload: targetDbSchema
                });
            } else {
                res.json({
                    success: true,
                    payload: dbSchema
                });
            }
        ////////////////////////////////////////
        } catch (/** @type {any} */ error) {
            _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
                component: "/api/query/get-schema/lines-132-142",
                message: error.message
            });
            ////////////////////////////////////////
            res.json({
                success: false,
                payload: null,
                error: error.message
            });
        }
    ////////////////////////////////////////
    } catch (/** @type {any} */ error1) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/query/get-schema/main-catch-error",
            message: error1.message
        });
        res.json({
            success: false,
            payload: null,
            msg: "Wrong Credentials"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2163,1007], () => (__webpack_exec__(1640)));
module.exports = __webpack_exports__;

})();