"use strict";
(() => {
var exports = {};
exports.id = 8360;
exports.ids = [8360];
exports.modules = {

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 4260:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var child_process__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2081);
/* harmony import */ var child_process__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(child_process__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_3__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);




/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "GET") return res.json({
        msg: "Failed!"
    });
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ let results;
    try {
        /**
         * User auth
         *
         * @description Authenticate user
         */ const authorization = req.headers.authorization;
        if (!authorization) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_3___default()({
            key: authorization
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        const { user_id , full_access  } = apiCred;
        if (!full_access) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        /**
         * Grab the database schema
         * @note This is only for one database
         * @type {import("@/package-shared/types").DSQL_DatabaseSchemaType}
         */ //@ts-ignore
        const schema = req.query.schema;
        /** @type {string} */ const dbSchemaPath = `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${user_id.toString().replace(/\//g, "")}/main.json`;
        /** @type {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} */ const dbSchema = JSON.parse(fs.readFileSync(dbSchemaPath, "utf8"));
        const targetDbSchemaIndex = dbSchema.findIndex((db)=>db.dbFullName == schema?.dbFullName);
        const targetDbSchema = schema?.dbFullName ? dbSchema.find((db)=>db.dbFullName == schema.dbFullName) : null;
        if (targetDbSchemaIndex < 0) {
            return res.json({
                success: false,
                payload: null
            });
        }
        dbSchema[targetDbSchemaIndex] = schema;
        fs.writeFileSync(dbSchemaPath, JSON.stringify(dbSchema, null, 4), "utf8");
        const targetPath = path.resolve(process.cwd(), "./shell");
        const dbShellUpdate = (0,child_process__WEBPACK_IMPORTED_MODULE_0__.execSync)(`node createDbFromSchema.js --user ${user_id.toString().replace(/\/| /g, "")} --database ${dbSchema[targetDbSchemaIndex].dbFullName}`, {
            cwd: targetPath
        });
        res.json({
            success: true,
            payload: "Success!"
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default()({
            component: "/api/query/update-schema-from-single-database/main-catch-error",
            message: error.message
        });
        res.json({
            success: false,
            payload: null,
            msg: "Something went wrong"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2163,1007], () => (__webpack_exec__(4260)));
module.exports = __webpack_exports__;

})();