"use strict";
(() => {
var exports = {};
exports.id = 5146;
exports.ids = [5146];
exports.modules = {

/***/ 6517:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 6354:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2224);
/* harmony import */ var _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1017);
/* harmony import */ var path__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(path__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _functions_backend_grabPaths__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6715);
/* harmony import */ var _functions_backend_grabPaths__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_grabPaths__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(6517);
/* harmony import */ var lodash__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(lodash__WEBPACK_IMPORTED_MODULE_5__);
// @ts-check
const fs = __webpack_require__(7147);
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////






/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        user: null,
        msg: "Registration Failed!"
    });
    /**
     * User Auth
     *
     * @description User Auth
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_0___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ // const { mediaObject, newName, replace } = req.body;
    const mediaObject = req.body.mediaObject;
    const newName = req.body.newName;
    const newThumbnailName = req.body.newThumbnailName;
    const replace = req.body.replace;
    /**
     * Validate Form
     *
     * @description Check if request body is valid
     */ try {
        const isProduction = "production".match(/production/);
        const fileExtension = mediaObject.media_url.match(/\..{3,4}$/)[0];
        const isPrivate = mediaObject?.private == 1 ? true : false;
        const STATIC_ROOT = process.env.DSQL_STATIC_SERVER_DIR;
        if (!STATIC_ROOT) {
            console.log("Static File ENV not Found!");
            throw new Error("No Static Path!");
        }
        const grabedPaths = _functions_backend_grabPaths__WEBPACK_IMPORTED_MODULE_4___default()({
            isPrivate: isPrivate,
            user: user,
            folder: mediaObject.folder ? mediaObject.folder + "/" : "",
            video: mediaObject.media_type?.match(/video/i) ? true : false
        });
        if (!grabedPaths) {
            throw new Error("Couldn't grab paths!");
        }
        const { fileRootPath , urlRootPath , relativePath  } = grabedPaths;
        const rootFolder = fileRootPath;
        let imagePath = rootFolder;
        const oldNamePath = `${imagePath}${mediaObject.media_name}${fileExtension}`;
        const newNamePath = `${imagePath}${newName}${fileExtension}`;
        const oldNameThumbnailPath = `${imagePath}${mediaObject.media_name}_thumbnail${fileExtension}`;
        const newNameThumbnailPath = `${imagePath}${newName}_thumbnail${fileExtension}`;
        const mediaNameRegex = new RegExp(lodash__WEBPACK_IMPORTED_MODULE_5___default().escapeRegExp(`${mediaObject.media_name}`));
        const newUrl = mediaObject.media_url.replace(mediaNameRegex, newName);
        const newThumbnailUrl = mediaObject.media_url.replace(mediaNameRegex, newName + "_thumbnail");
        const newPath = mediaObject.media_path ? mediaObject.media_path.replace(mediaNameRegex, newName) : `${relativePath}${newName}`;
        const newThumbnailPath = mediaObject.media_thumbnail_path ? mediaObject.media_thumbnail_path.replace(mediaNameRegex, newName) : `${relativePath}${newThumbnailName}`;
        if (fs.existsSync(newNamePath) && !replace) {
            return res.json({
                success: false,
                msg: "File already exists"
            });
        }
        fs.renameSync(oldNamePath, newNamePath);
        try {
            fs.renameSync(oldNameThumbnailPath, newNameThumbnailPath);
        } catch (error) {
        // console.log(`ERROR in 'renameMedia' API route => ${error.message}`);
        }
        const updateMediaName = await _package_shared_utils_backend_global_db_DB_HANDLER__WEBPACK_IMPORTED_MODULE_2___default()(`UPDATE user_media SET media_name = ?, media_url = ?, media_thumbnail_url = ?, media_path = ?, media_thumbnail_path = ? WHERE id = ?`, [
            newName,
            newUrl,
            newThumbnailUrl,
            newPath,
            newThumbnailPath,
            mediaObject.id, 
        ]);
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        res.json({
            success: true
        });
    ////////////////////////////////////////
    ////////////////////////////////////////
    ////////////////////////////////////////
    } catch (/** @type {any} */ error1) {
        console.log("Error in renaming media =>", error1.message);
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/renameMedia/catch-error",
            message: error1.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Renaming failed. Please try again."
        });
    }
////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,6715], () => (__webpack_exec__(6354)));
module.exports = __webpack_exports__;

})();