"use strict";
(() => {
var exports = {};
exports.id = 2114;
exports.ids = [2114];
exports.modules = {

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 2081:
/***/ ((module) => {

module.exports = require("child_process");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 1724:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(1352);
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);
const path = __webpack_require__(1017);
const { execSync  } = __webpack_require__(2081);



/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_2___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ const { tableData  } = req.body;
    const database = req.body.database;
    const dbSlug = req.body.dbSlug;
    const delegated = req.body.delegated;
    const dbFullName = database.replace(/[^a-z\_0-9]/g, "");
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ const delegatedUser = await _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_0___default()({
            request: req,
            user: user,
            databaseSlug: dbSlug,
            query: req.query
        });
        const userId = delegatedUser?.rootUserId ? delegatedUser.rootUserId : user.id;
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ const userSchemaMainFilePath = `${process.env.DSQL_USER_DB_SCHEMA_PATH}/user-${userId}/main.json`;
        /** @type {import("@/package-shared/types").DSQL_DatabaseSchemaType[]} */ const userSchemaObject = JSON.parse(fs.readFileSync(userSchemaMainFilePath, "utf-8"));
        const targetDbIndex = userSchemaObject.findIndex((db)=>db.dbFullName === database);
        const targetTableIndex = userSchemaObject[targetDbIndex].tables.findIndex((tb)=>tb.childTable && tb.childTableDbFullName === tableData.childTableDbFullName && tb.childTableName === tableData.childTableName && tb.tableName === tableData.tableName);
        userSchemaObject[targetDbIndex].tables[targetTableIndex] = tableData;
        fs.writeFileSync(`${userSchemaMainFilePath}`, JSON.stringify(userSchemaObject), "utf8");
        const targetPath = path.join(process.cwd(), "/shell");
        const dbShellUpdate = execSync(`node createDbFromSchema.js --user ${userId} --database ${dbFullName}`, {
            cwd: targetPath
        });
        res.json({
            success: true
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        console.log(error.message);
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_1___default()({
            component: "/api/addApiKey/catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Foreign Key update Failed."
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,1352], () => (__webpack_exec__(1724)));
module.exports = __webpack_exports__;

})();