"use strict";
(() => {
var exports = {};
exports.id = 1351;
exports.ids = [1351];
exports.modules = {

/***/ 6109:
/***/ ((module) => {

module.exports = require("sanitize-html");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 3685:
/***/ ((module) => {

module.exports = require("http");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 8560:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(766);
/* harmony import */ var _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _functions_backend_checkUserRights__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(8999);
/* harmony import */ var _functions_backend_checkUserRights__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_checkUserRights__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(1352);
/* harmony import */ var _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(6825);
/* harmony import */ var _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_4__);
/* harmony import */ var _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(5886);
/* harmony import */ var _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_5__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ 





/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * User auth
     *
     * @description Authenticate user
     */ const user = await _functions_backend_userAuth__WEBPACK_IMPORTED_MODULE_4___default()(req, res, true);
    if (!user) {
        return res.json({
            success: false,
            msg: "Unauthorized"
        });
    }
    /**
     * User auth
     *
     * @description Authenticate user
     */ const sanitizedReqBody = req.body;
    const { dbSlug , tableName , payload , entryId , tableSchema , delegated , dbId ,  } = sanitizedReqBody;
    /**
     * Remove Default Fields
     *
     * @description Remove Default Fields
     */ delete payload["id"];
    delete payload["uuid"];
    delete payload["date_created"];
    delete payload["date_created_code"];
    delete payload["date_created_timestamp"];
    delete payload["date_updated"];
    delete payload["date_updated_code"];
    delete payload["date_updated_timestamp"];
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /**
         * Check if user has rights to this table
         *
         * @description Check if user has rights to this table
         */ const delegatedUser = await _functions_backend_grabDelegatedUserFromCookie__WEBPACK_IMPORTED_MODULE_2___default()({
            databaseSlug: dbSlug,
            request: req,
            user: user,
            query: req.query
        });
        const dbFullName = delegatedUser?.rootUserId ? `datasquirel_user_${delegatedUser.rootUserId}_${dbSlug}` : `datasquirel_user_${user.id}_${dbSlug}`;
        const checkUserRightsBoolean = await _functions_backend_checkUserRights__WEBPACK_IMPORTED_MODULE_1___default()({
            user: user,
            confirmedDelegetedUser: delegatedUser,
            database: dbSlug,
            table: tableName,
            dbId: dbId,
            priviledgeRegex: /Update Entries/i
        });
        if (!checkUserRightsBoolean) {
            return res.json({
                success: false,
                msg: "Unauthorized"
            });
        }
        /**
         * Create new user folder and file
         *
         * @description Create new user folder and file
         */ /** @type {any} */ const updateTableEntry = await _package_shared_functions_backend_db_updateDbEntry__WEBPACK_IMPORTED_MODULE_5___default()({
            dbContext: "Dsql User",
            paradigm: "Full Access",
            dbFullName: dbFullName,
            tableName: tableName,
            identifierColumnName: "id",
            identifierValue: entryId,
            data: payload,
            tableSchema: tableSchema
        });
        ////////////////////////////////////////
        if (updateTableEntry?.error) {
            throw new Error(updateTableEntry.error);
        }
        if (!updateTableEntry) {
            throw new Error("No result returned!");
        }
        ////////////////////////////////////////
        const handleOrder = await _functions_backend_handleTableEntryOrder__WEBPACK_IMPORTED_MODULE_0___default()({
            dbName: dbFullName,
            entryId: entryId,
            entryOrder: payload.order,
            tableName: tableName,
            tableSchema: tableSchema
        });
        ////////////////////////////////////////
        res.json({
            success: true,
            payload: updateTableEntry
        });
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_3___default()({
            component: "/api/updateTableEntry/main-catch-error",
            message: error.message,
            user: user
        });
        res.json({
            success: false,
            msg: "Database Files could not be written!",
            err: error.message
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,6825,3017,3403,7547,5886,1352,8999,766], () => (__webpack_exec__(8560)));
module.exports = __webpack_exports__;

})();