"use strict";
(() => {
var exports = {};
exports.id = 3173;
exports.ids = [3173];
exports.modules = {

/***/ 2029:
/***/ ((module) => {

module.exports = require("datasquirel/functions/hashPassword");

/***/ }),

/***/ 2261:
/***/ ((module) => {

module.exports = require("serverless-mysql");

/***/ }),

/***/ 4300:
/***/ ((module) => {

module.exports = require("buffer");

/***/ }),

/***/ 6113:
/***/ ((module) => {

module.exports = require("crypto");

/***/ }),

/***/ 7147:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 1017:
/***/ ((module) => {

module.exports = require("path");

/***/ }),

/***/ 5425:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

// @ts-check

const { scryptSync , createDecipheriv  } = __webpack_require__(6113);
const { Buffer  } = __webpack_require__(4300);
/**
 * @param {string} encryptedString
 * @returns {string | null}
 */ const decrypt = (encryptedString)=>{
    const algorithm = "aes-192-cbc";
    const password = process.env.DSQL_ENCRYPTION_PASSWORD || "";
    const salt = process.env.DSQL_ENCRYPTION_SALT || "";
    let key = scryptSync(password, salt, 24);
    let iv = Buffer.alloc(16, 0);
    // @ts-ignore
    const decipher = createDecipheriv(algorithm, key, iv);
    try {
        let decrypted = decipher.update(encryptedString, "hex", "utf8");
        decrypted += decipher.final("utf8");
        return decrypted;
    } catch (error) {
        return null;
    }
};
module.exports = decrypt;


/***/ }),

/***/ 5827:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ handler)
/* harmony export */ });
/* harmony import */ var datasquirel_functions_hashPassword__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2029);
/* harmony import */ var datasquirel_functions_hashPassword__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(datasquirel_functions_hashPassword__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(5425);
/* harmony import */ var _package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_decrypt__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(2163);
/* harmony import */ var _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(1311);
/* harmony import */ var _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(1007);
/* harmony import */ var _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4___default = /*#__PURE__*/__webpack_require__.n(_package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4__);
// @ts-check
/**
 * ==============================================================================
 * Imports
 * ==============================================================================
 */ const fs = __webpack_require__(7147);





/** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /** ****************************************************************************** */ /**
 * API handler
 * ==============================================================================
 * @type {import("next").NextApiHandler}
 */ async function handler(req, res) {
    /**
     * Check method
     *
     * @description Check request method and return if invalid
     */ if (req.method !== "POST") return res.json({
        msg: "Failed!"
    });
    /**
     * Send Response
     *
     * @description Send a boolean response
     */ try {
        /** @type {import("@/package-shared/types").PackageUserLoginRequestBody} */ const reqBody = req.body;
        const { encryptionKey , payload , database , additionalFields , email_login , email_login_code , email_login_field , token ,  } = reqBody;
        const authorization = req.headers.authorization;
        const apiCred = _package_shared_functions_backend_api_cred__WEBPACK_IMPORTED_MODULE_4___default()({
            key: authorization,
            database
        });
        if (!apiCred?.user_id) {
            throw new Error("Api Credentials invalid!");
        }
        if (!apiCred.full_access || !apiCred.sign) return res.json({
            success: false,
            msg: "Unauthorized"
        });
        /**
         * User auth
         *
         * @description Authenticate user
         */ const email = payload.email;
        const username = payload.username;
        const password = payload.password;
        const dbFullName = `datasquirel_user_${apiCred.user_id}_${database}`;
        /**
         * Check input validity
         *
         * @description Check input validity
         */ if (email?.match(/ /) || username && username?.match(/ /) || password && password?.match(/ /)) {
            return res.json({
                success: false,
                msg: "Invalid Email/Password format"
            });
        }
        /**
         * Password hash
         *
         * @description Password hash
         */ let hashedPassword = password ? datasquirel_functions_hashPassword__WEBPACK_IMPORTED_MODULE_0___default()({
            encryptionKey: encryptionKey,
            password: password
        }) : null;
        let isSocialValidated = false;
        let loginFailureReason = null;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        let foundUser = await _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_3___default()({
            queryString: `SELECT * FROM users WHERE email = ? OR username = ?`,
            queryValuesArray: [
                email,
                username
            ],
            database: dbFullName.replace(/[^a-z0-9_]/g, "")
        });
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        if ((!foundUser || !foundUser[0]) && !reqBody.social) return res.json({
            success: false,
            payload: null,
            msg: "No user found"
        });
        let isPasswordCorrect = false;
        if (foundUser && foundUser[0] && !email_login) {
            isPasswordCorrect = hashedPassword === foundUser[0].password;
        } else if (foundUser && foundUser[0] && email_login && email_login_code && email_login_field) {
            /** @type {string} */ const tempCode = foundUser[0][email_login_field];
            if (!tempCode) throw new Error("No code Found!");
            const tempCodeArray = tempCode.split("-");
            const [code, codeDate] = tempCodeArray;
            const millisecond15mins = 1000 * 60 * 15;
            if (Date.now() - Number(codeDate) > millisecond15mins) {
                throw new Error("Code Expired");
            }
            isPasswordCorrect = code === email_login_code;
        }
        let socialUserValid = false;
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        if (!isPasswordCorrect && !socialUserValid) {
            return res.json({
                success: false,
                msg: "Wrong password, no social login validity",
                payload: null
            });
        }
        if (isPasswordCorrect && email_login) {
            const resetTempCode = await _package_shared_functions_backend_varDatabaseDbHandler__WEBPACK_IMPORTED_MODULE_3___default()({
                queryString: `UPDATE users SET ${email_login_field} = ? WHERE email = ? OR username = ?`,
                queryValuesArray: [
                    "",
                    email,
                    username
                ],
                database: dbFullName.replace(/[^a-z0-9_]/g, "")
            });
        }
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        let csrfKey = Math.random().toString(36).substring(2) + "-" + Math.random().toString(36).substring(2);
        let userPayload = {
            id: foundUser[0].id,
            first_name: foundUser[0].first_name,
            last_name: foundUser[0].last_name,
            username: foundUser[0].username,
            email: foundUser[0].email,
            phone: foundUser[0].phone,
            social_id: foundUser[0].social_id,
            image: foundUser[0].image,
            image_thumbnail: foundUser[0].image_thumbnail,
            verification_status: foundUser[0].verification_status,
            social_login: foundUser[0].social_login,
            social_platform: foundUser[0].social_platform,
            csrf_k: csrfKey,
            more_data: foundUser[0].more_user_data,
            logged_in_status: true,
            date: Date.now()
        };
        const resposeObject = {
            success: true,
            msg: "Login Successful",
            payload: userPayload,
            userId: apiCred.user_id
        };
        if (additionalFields && Array.isArray(additionalFields) && additionalFields.length > 0) {
            additionalFields.forEach((key)=>{
                // @ts-ignore
                userPayload[key] = foundUser[0][key];
            });
        }
        // if (token) {
        //     resposeObject.token =
        // }
        ////////////////////////////////////////
        ////////////////////////////////////////
        ////////////////////////////////////////
        /** ********************* Send Response */ res.json(resposeObject);
    ////////////////////////////////////////
    } catch (/** @type {any} */ error) {
        ////////////////////////////////////////
        _functions_backend_serverError__WEBPACK_IMPORTED_MODULE_2___default()({
            component: "/api/user/login-user/main-catch-error",
            message: error.message,
            user: {}
        });
        res.json({
            success: false,
            msg: "Login Failed"
        });
    ////////////////////////////////////////
    }
}


/***/ })

};
;

// load runtime
var __webpack_require__ = require("../../../webpack-api-runtime.js");
__webpack_require__.C(exports);
var __webpack_exec__ = (moduleId) => (__webpack_require__(__webpack_require__.s = moduleId))
var __webpack_exports__ = __webpack_require__.X(0, [2224,2163,3017,3403,8326,1311,1007], () => (__webpack_exec__(5827)));
module.exports = __webpack_exports__;

})();